"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _reduxQuery = require("redux-query");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

/**
 * Other hooks are guaranteed to only receive a new Redux action if and only if the query key of
 * the provided queryConfig changes.
 */
const useMemoizedAction = (queryConfig, transform) => {
  const [memoizedAction, setMemoizedAction] = React.useState(queryConfig ? transform(queryConfig) : null);
  const previousQueryKey = React.useRef((0, _reduxQuery.getQueryKey)(queryConfig));
  React.useEffect(() => {
    const queryKey = (0, _reduxQuery.getQueryKey)(queryConfig);

    if (queryKey !== previousQueryKey.current) {
      previousQueryKey.current = queryKey;
      setMemoizedAction(queryConfig ? transform(queryConfig) : null);
    }
  }, [queryConfig, transform]);
  return memoizedAction;
};

var _default = useMemoizedAction;
exports.default = _default;